"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var JSONTraverse_1 = require("./cucumber-js/JSONTraverse");
var JSONTraverse_2 = require("./cucumber-ruby/JSONTraverse");
var JSONTraverse_3 = require("./behave/JSONTraverse");
function traverseFeature(implementation, feature, astMaker, newId, predictableSupportCode) {
    if (implementation === 'cucumber-js') {
        return traverseJS(feature, astMaker, newId, predictableSupportCode);
    }
    if (implementation === 'behave') {
        return traverseBehave(feature, astMaker, newId, predictableSupportCode);
    }
    return traverseRuby(feature, astMaker, newId, predictableSupportCode);
}
exports.default = traverseFeature;
function traverseJS(feature, astMaker, newId, predictableSupportCode) {
    return JSONTraverse_1.traverseFeature(feature, astMaker, newId, predictableSupportCode);
}
function traverseRuby(feature, astMaker, newId, predictableSupportCode) {
    return JSONTraverse_2.traverseFeature(feature, astMaker, newId, predictableSupportCode);
}
function traverseBehave(feature, astMaker, newId, predictableSupportCode) {
    return JSONTraverse_3.traverseFeature(feature, astMaker, newId, predictableSupportCode);
}
//# sourceMappingURL=JSONTraverse.js.map