"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var commander_1 = require("commander");
var package_json_1 = __importDefault(require("../package.json"));
var jsonToMessages_1 = __importDefault(require("./jsonToMessages"));
var detectImplementations_1 = __importDefault(require("./detectImplementations"));
var program = new commander_1.Command();
program.version(package_json_1.default.version);
program.option('-i, --implementation <implementation>', 'Cucumber implementation used to generate the report: cucumber-ruby|cucumber-js|behave', '');
program.option('-d, --detect', 'Output detected language from JSON report', '');
program.parse(process.argv);
var lang = program.lang, detect = program.detect;
if (detect) {
    detectImplementations_1.default(process.stdin)
        .then(function (implementations) {
        process.stdout.write("Detected implementations:\n" + implementations + "\n");
    })
        .catch(function (err) {
        console.error(err);
        process.exit(1);
    });
}
else {
    jsonToMessages_1.default(process.stdin, process.stdout, lang).catch(function (err) {
        console.error(err);
        process.exit(1);
    });
}
//# sourceMappingURL=cli.js.map