"use strict";
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
function traverseFeature(feature, astMaker, newId, predictableSupportCode, traverseElement) {
    var e_1, _a;
    var children = [];
    var backgroundFound = false;
    var tags = feature.tags
        ? feature.tags.map(function (tag) { return traverseTag(tag, astMaker); })
        : undefined;
    try {
        for (var _b = __values(feature.elements), _c = _b.next(); !_c.done; _c = _b.next()) {
            var element = _c.value;
            var isBackground = element.type === 'background';
            if (!isBackground || !backgroundFound) {
                children.push(traverseElement(element, astMaker, newId, predictableSupportCode));
            }
            backgroundFound = backgroundFound || isBackground;
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        }
        finally { if (e_1) throw e_1.error; }
    }
    var gherkinFeature = astMaker.makeFeature(feature.line, feature.keyword, feature.name, feature.description, children.filter(function (child) { return child; }), tags);
    return astMaker.makeGherkinDocument(feature.uri, gherkinFeature);
}
exports.traverseFeature = traverseFeature;
function traverseTag(tag, astMaker) {
    return astMaker.makeTag(tag.name, tag.line);
}
exports.traverseTag = traverseTag;
//# sourceMappingURL=JSONTraverse.js.map