import { IdGenerator, messages } from '@cucumber/messages';
import { IStep, IDocString, IDataTableRow, IElement } from './JSONSchema';
import IAstMaker from '../IAstMaker';
import IPredictableSupportCode from '../IPredictableSupportCode';
import { IFeature } from '../cucumber-generic/JSONSchema';
export declare function traverseFeature(feature: IFeature, astMaker: IAstMaker, newId: IdGenerator.NewId, predictableSupportCode: IPredictableSupportCode): messages.IGherkinDocument;
export declare function traverseElement(element: IElement, astMaker: IAstMaker, newId: IdGenerator.NewId, predictableSupportCode: IPredictableSupportCode): messages.GherkinDocument.Feature.IFeatureChild;
export declare function traverseStep(step: IStep, astMaker: IAstMaker, newId: IdGenerator.NewId, predictableSupportCode: IPredictableSupportCode): messages.GherkinDocument.Feature.IStep;
export declare function traverseDocString(docString: IDocString, astMaker: IAstMaker): messages.GherkinDocument.Feature.Step.IDocString;
export declare function traverseDataTable(rows: ReadonlyArray<IDataTableRow>, astMaker: IAstMaker): messages.GherkinDocument.Feature.Step.IDataTable;
