"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var messages_1 = require("@cucumber/messages");
var PredictableTestSteps_1 = require("../PredictableTestSteps");
function makePredictablePickleTestStep(testStepId, pickleStep, stepDefinitions) {
    var matching = stepDefinitions.filter(function (stepDefinition) {
        return stepDefinition.match(pickleStep);
    });
    if (matching.length > 0) {
        return new PredictableTestSteps_1.PredictablePickleTestStep(testStepId, pickleStep.id, false, matching[0].id, matching[0].status, matching[0].duration, matching[0].errorMessage);
    }
    else {
        return new PredictableTestSteps_1.PredictablePickleTestStep(testStepId, pickleStep.id, false, null, messages_1.messages.TestStepFinished.TestStepResult.Status.UNDEFINED, 0, null);
    }
}
exports.default = makePredictablePickleTestStep;
//# sourceMappingURL=makePredictablePickleTestStep.js.map